OpenTTD Source: src/newgrf_commons.cpp File Reference

OpenTTD Source 14.0-beta3

Functions
newgrf_commons.cpp File Reference
`#include "stdafx.h"`
`#include "debug.h"`
`#include "landscape.h"`
`#include "house.h"`
`#include "industrytype.h"`
`#include "newgrf_config.h"`
`#include "clear_map.h"`
`#include "station_map.h"`
`#include "tree_map.h"`
`#include "tunnelbridge_map.h"`
`#include "newgrf_object.h"`
`#include "genworld.h"`
`#include "newgrf_spritegroup.h"`
`#include "newgrf_text.h"`
`#include "company_base.h"`
`#include "error.h"`
`#include "strings_func.h"`
`#include "string_func.h"`
`#include "table/strings.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Functions
uint32_t | GetTerrainType (TileIndex tile, TileContext context)
| Function used by houses (and soon industries) to get information on type of "terrain" the tile it is queries sits on. More...
TileIndex | GetNearbyTile (byte parameter, TileIndex tile, bool signed_offsets, Axis axis)
| Get the tile at the given offset. More...
uint32_t | GetNearbyTileInformation (TileIndex tile, bool grf_version8)
| Common part of station var 0x67, house var 0x62, indtile var 0x60, industry var 0x62. More...
uint32_t | GetCompanyInfo (CompanyID owner, const Livery *l)
| Returns company information like in vehicle var 43 or station var 43. More...
CommandCost | GetErrorMessageFromLocationCallbackResult (uint16_t cb_res, const GRFFile *grffile, StringID default_error)
| Get the error message from a shape/location/slope check callback result. More...
void | ErrorUnknownCallbackResult (uint32_t grfid, uint16_t cbid, uint16_t cb_res)
| Record that a NewGRF returned an unknown/invalid callback result. More...
bool | ConvertBooleanCallback (const GRFFile *grffile, uint16_t cbid, uint16_t cb_res)
| Converts a callback result into a boolean. More...
bool | Convert8bitBooleanCallback (const GRFFile *grffile, uint16_t cbid, uint16_t cb_res)
| Converts a callback result into a boolean. More...

## Detailed Description

Implementation of the class OverrideManagerBase and its descendance, present and future.

Definition in file newgrf_commons.cpp.

## Function Documentation

## ◆ Convert8bitBooleanCallback()

bool Convert8bitBooleanCallback | ( | const GRFFile * | grffile,
|  | uint16_t | cbid,
|  | uint16_t | cb_res
| ) |  |

Converts a callback result into a boolean.

For grf version < 8 the first 8 bit of the result are checked for zero or non-zero. For grf version >= 8 the callback result must be 0 or 1.

Parameters

  grffile | NewGRF returning the value.
  cbid | Callback returning the value.
  cb_res | Callback result.

Returns
  Boolean value. True if cb_res != 0.

Definition at line 548 of file newgrf_commons.cpp.

## ◆ ConvertBooleanCallback()

bool ConvertBooleanCallback | ( | const GRFFile * | grffile,
|  | uint16_t | cbid,
|  | uint16_t | cb_res
| ) |  |

Converts a callback result into a boolean.

For grf version < 8 the result is checked for zero or non-zero. For grf version >= 8 the callback result must be 0 or 1.

Parameters

  grffile | NewGRF returning the value.
  cbid | Callback returning the value.
  cb_res | Callback result.

Returns
  Boolean value. True if cb_res != 0.

Definition at line 529 of file newgrf_commons.cpp.

## ◆ ErrorUnknownCallbackResult()

void ErrorUnknownCallbackResult | ( | uint32_t | grfid,
|  | uint16_t | cbid,
|  | uint16_t | cb_res
| ) |  |

Record that a NewGRF returned an unknown/invalid callback result.

Also show an error to the user.

Parameters

  grfid | ID of the NewGRF causing the problem.
  cbid | Callback causing the problem.
  cb_res | Invalid result returned by the callback.

Definition at line 499 of file newgrf_commons.cpp.

## ◆ GetCompanyInfo()

uint32_t GetCompanyInfo | ( | CompanyID | owner,
|  | const Livery * | l
| ) |  |

Returns company information like in vehicle var 43 or station var 43.

Parameters

  owner | Owner of the object.
  l | Livery of the object; nullptr to use default.

Returns
  NewGRF company information.

Definition at line 450 of file newgrf_commons.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), and Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID().

Referenced by VehicleScopeResolver::GetVariable(), and StationScopeResolver::GetVariable().

## ◆ GetErrorMessageFromLocationCallbackResult()

CommandCost GetErrorMessageFromLocationCallbackResult | ( | uint16_t | cb_res,
|  | const GRFFile * | grffile,
|  | StringID | default_error
| ) |  |

Get the error message from a shape/location/slope check callback result.

Parameters

  cb_res | Callback result to translate. If bit 10 is set this is a standard error message, otherwise a NewGRF provided string.
  grffile | NewGRF to use to resolve a custom error message.
  default_error | Error message to use for the generic error.

Returns
  CommandCost indicating success or the error message.

Definition at line 463 of file newgrf_commons.cpp.

## ◆ GetNearbyTile()

TileIndex GetNearbyTile | ( | byte | parameter,
|  | TileIndex | tile,
|  | bool | signed_offsets,
|  | Axis | axis
| ) |  |

Get the tile at the given offset.

Parameters

  parameter | The NewGRF "encoded" offset.
  tile | The tile to base the offset from.
  signed_offsets | Whether the offsets are to be interpreted as signed or not.
  axis | Axis of a railways station.

Returns
  The tile at the offset.

Definition at line 406 of file newgrf_commons.cpp.

Referenced by GetNearbyAirportTileInformation(), GetNearbyIndustryTileInformation(), GetNearbyObjectTileInformation(), GetNearbyTileInformation(), AirportTileScopeResolver::GetVariable(), StationScopeResolver::GetVariable(), and ObjectScopeResolver::GetVariable().

## ◆ GetNearbyTileInformation()

uint32_t GetNearbyTileInformation | ( | TileIndex | tile,
|  | bool | grf_version8
| ) |  |

Common part of station var 0x67, house var 0x62, indtile var 0x60, industry var 0x62.

Parameters

  tile | the tile of interest.
  grf_version8 | True, if we are dealing with a new NewGRF which uses GRF version >= 8.

Returns
  0czzbbss: c = TileType; zz = TileZ; bb: 7-3 zero, 4-2 TerrainType, 1 water/shore, 0 zero; ss = TileSlope

Definition at line 429 of file newgrf_commons.cpp.

References GetTerrainType(), GetTilePixelSlope(), GetTileType(), GetTreeGround(), GetWaterClass(), HasTileWaterClass(), IsTileType(), MP_TREES, MP_WATER, TILE_HEIGHT, and TREE_GROUND_SHORE.

Referenced by GetNearbyAirportTileInformation(), GetNearbyIndustryTileInformation(), and GetNearbyObjectTileInformation().

## ◆ GetTerrainType()

uint32_t GetTerrainType | ( | TileIndex | tile,
|  | TileContext | context
| ) |  |

Function used by houses (and soon industries) to get information on type of "terrain" the tile it is queries sits on.

Parameters

  tile | TileIndex of the tile been queried
  context | The context of the tile.

Returns
  value corresponding to the grf expected format: Terrain type: 0 normal, 1 desert, 2 rainforest, 4 on or above snowline

Definition at line 331 of file newgrf_commons.cpp.

References _settings_game, GameSettings::game_creation, and GameCreationSettings::landscape.

Referenced by GetNearbyTileInformation(), CanalScopeResolver::GetVariable(), IndustryTileScopeResolver::GetVariable(), IndustriesScopeResolver::GetVariable(), AirportTileScopeResolver::GetVariable(), HouseScopeResolver::GetVariable(), and ObjectScopeResolver::GetVariable().